# frozen_string_literal: true
require 'rails/generators/base'

module NexusCqrs
  class CommandGenerator < Rails::Generators::NamedBase
    source_root File.expand_path('templates', __dir__)
    class_option :permission, type: :string, default: nil

    def copy_command_file
      file_path = class_name.underscore

      @permission = options['permission']

      template('command.rb', "app/domain/commands/#{file_path}.rb")
      template('command_handler.rb', "app/domain/commands/#{file_path}_handler.rb")

      register_command
    end

    private

    def register_command
      handler_config = 'config/initializers/register_cqrs_handlers.rb'

      unless File.exist?('config/initializers/register_cqrs_handlers.rb')
        template('register_cqrs_handlers.rb', handler_config)
      end
    end
  end
end
