# frozen_string_literal: true
require 'rails/generators/base'

module NexusCqrs
  class QueryGenerator < Rails::Generators::NamedBase
    source_root File.expand_path('templates', __dir__)
    class_option :permission, type: :string, default: nil

    def copy_query_file
      file_path = class_name.underscore

      @permission = options['permission']

      template('query.rb', "app/domain/queries/#{file_path}.rb")
      template('query_handler.rb', "app/domain/queries/#{file_path}_handler.rb")

      register_query
    end

    private

    def register_query
      handler_config = 'config/initializers/register_cqrs_handlers.rb'

      unless File.exist?('config/initializers/register_cqrs_handlers.rb')
        template('register_cqrs_handlers.rb', handler_config)
      end
    end
  end
end
