# frozen_string_literal: true
module Commands
  # Command handler
  class <%= class_name %>Handler < BaseCommandHandler
    <% if @permission %>include NexusCqrs::Helpers<% end %>

    # @param [<%= class_name %>] command
    def call(command)
      <% if @permission %>authorize(command, Model)<% end %>

      domain_event(command)
    end

    private

      def domain_event(command)
        NexusDomainEvents::Event.new(
          message_name: :ENTITY_WAS_ACTIONED,
          actor: command.metadata[:current_user].member_id,
          payload: {
            object_id: command.id,
          }
        )
      end
  end
end