# frozen_string_literal: true
module NexusCqrs
  module Auth
    # Class used to provide additional context into pundit. This enables us to not only pass the user model, but also
    # the global permissions for that user - as those are pulled from the user's request, not the model.
    class UserContext
      attr_reader :user, :global_permissions

      def initialize(user, global_permissions)
        @user = user
        @global_permissions = global_permissions
      end
    end
  end
end
