# frozen_string_literal: true
module NexusCqrs
  # Base class for all command handlers. Should always declare a `call` method for invoking the handler.
  #
  # @since 0.1.0
  class BaseCommandHandler
    include NexusCqrs::Auth

    # Method for invoking this handler - all command logic should be contained in this method.
    #
    # @param [NexusCqrs::BaseCommand] command Command to be executed by this handler
    def call(command)
    end
  end
end
