# frozen_string_literal: true
module NexusCqrs
  # Base middleware class to allow custom middleware to be injected into the command bus
  #
  # @abstract
  # @since 0.1.0
  class BaseMiddleware
    def initialize(next_)
      @next = next_
    end

    # Invoke middleware
    #
    # @param [BaseMessage] message Message object being passed to the bus
    def call(message)
    end
  end
end
