# frozen_string_literal: true
module NexusCqrs
  # Base class for all query handlers. Should always declare a `call` method for invoking the handler.
  #
  # @since 0.1.0
  class BaseQueryHandler
    include NexusCqrs::Auth

    # Method for invoking this handler - all query logic should be contained in this method.
    #
    # @param [NexusCqrs::BaseQuery] query Query to be executed by this handler
    def call(query)
    end
  end
end
