# frozen_string_literal: true
require_relative '../../lib/nexus_cqrs'

class TestMessage < NexusCqrs::BaseMessage
  attr_reader :property
  def initialize(property)
    @property = property
  end
end

describe NexusCqrs::BaseMessage do
  it "allows metadata to be set and read" do
    command = NexusCqrs::BaseMessage.new
    expect(command.metadata).to(be_an_instance_of(Hash))
    expect(command.metadata.size).to(eq(0))

    command.set_metadata('test', 'dummy')
    expect(command.metadata[:test]).to(eq('dummy'))
  end

  it "returns null if non existent metadata is accessed" do
    command = NexusCqrs::BaseMessage.new
    expect(command.metadata[:test]).to(be(nil))
  end
end
