# frozen_string_literal: true
require_relative '../../lib/nexus_cqrs'

require_relative 'get_something'
require_relative 'get_something_handler'
require_relative 'commands/get_something_else'
require_relative 'commands/get_something_else_handler'

describe NexusCqrs::CommandBus do
  let(:command_bus) { NexusCqrs::CommandBus.new }
  let(:command_executor) { NexusCqrs::CommandExecutor.new(command_bus) }

  it "autoregistering works correctly" do
    command_executor.autoregister(NexusCqrs::BaseQuery, 'spec/lib', ['.rb', 'spec/lib/'])

    # Note we avoid asserting TestQuery generated by QueryGeneratorSpec as test will not work standalone.
    expect { GetSomething }.not_to raise_error
    expect { GetSomethingHandler }.not_to raise_error
    expect { Commands::GetSomethingElse }.not_to raise_error
    expect { Commands::GetSomethingElseHandler }.not_to raise_error

    expect(command_executor.command_bus.registered_handlers[GetSomething]).not_to(be(nil))
    expect(command_executor.command_bus.registered_handlers[GetSomething]).to(be_a_kind_of(GetSomethingHandler))
    expect(command_executor.command_bus.registered_handlers[GetSomething]).not_to(be_a_kind_of(Commands::GetSomethingElseHandler))
    expect(command_executor.command_bus.registered_handlers[Commands::GetSomethingElse]).not_to(be(nil))
    expect(command_executor.command_bus.registered_handlers[Commands::GetSomethingElse]).to(be_a_kind_of(Commands::GetSomethingElseHandler))
  end
end
