# frozen_string_literal: true
require "generator_spec"
require_relative '../../../lib/generators/nexus_cqrs/query_generator'

describe NexusCqrs::QueryGenerator, type: :generator do
  destination File.expand_path("../../tmp", __FILE__)

  before(:all) do
    prepare_destination
    run_generator ["TestQuery"]
  end

  it "creates the registration config file for handlers" do
    assert_file "config/initializers/register_cqrs_handlers.rb"
    assert_file "app/domain/queries/test_query.rb"
    assert_file "app/domain/queries/test_query_handler.rb"
  end

  context 'namespacing class names' do
    before(:all) do
      prepare_destination
      run_generator ["Test::TestQuery"]
    end

    it "creates the registration config file for handlers" do
      assert_file "config/initializers/register_cqrs_handlers.rb"
      assert_file "app/domain/queries/test/test_query.rb"
      assert_file "app/domain/queries/test/test_query_handler.rb"
    end
  end
end
